## mandos 1.7.19

=== Makefile ===
WARN:=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
	-Wunused -Wuninitialized -Wstrict-overflow=5 \
	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
	-Wsuggest-attribute=noreturn -Wfloat-equal -Wundef -Wshadow \
	-Wunsafe-loop-optimizations -Wpointer-arith \
	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
	-Wconversion -Wlogical-op -Waggregate-return \
	-Wstrict-prototypes -Wold-style-definition \
	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
	-Wredundant-decls -Wnested-externs -Winline -Wvla \
	-Wvolatile-register-var -Woverlength-strings
#DEBUG:=-ggdb3 -fsanitize=address 
# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
FORTIFY:=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
# <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
        -fsanitize=shift -fsanitize=integer-divide-by-zero \
        -fsanitize=unreachable -fsanitize=vla-bound -fsanitize=null \
        -fsanitize=return -fsanitize=signed-integer-overflow \
        -fsanitize=bounds -fsanitize=alignment \
        -fsanitize=object-size -fsanitize=float-divide-by-zero \
        -fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
        -fsanitize=returns-nonnull-attribute -fsanitize=bool \
        -fsanitize=enum
# Check which sanitizing options can be used
SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
	-o /dev/null >/dev/null 2>&1 && echo $(option)))
LINK_FORTIFY_LD:=-z relro -z now
LINK_FORTIFY:=

# If BROKEN_PIE is set, do not build with -pie
ifndef BROKEN_PIE
FORTIFY += -fPIE
LINK_FORTIFY += -pie
endif
#COVERAGE=--coverage
OPTIMIZE:=-Os -fno-strict-aliasing
LANGUAGE:=-std=gnu11
htmldir:=man
version:=1.7.19
SED:=sed

USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))

## Use these settings for a traditional /usr/local install
# PREFIX:=$(DESTDIR)/usr/local
# CONFDIR:=$(DESTDIR)/etc/mandos
# KEYDIR:=$(DESTDIR)/etc/mandos/keys
# MANDIR:=$(PREFIX)/man
# INITRAMFSTOOLS:=$(DESTDIR)/etc/initramfs-tools
# STATEDIR:=$(DESTDIR)/var/lib/mandos
# LIBDIR:=$(PREFIX)/lib
##

## These settings are for a package-type install
PREFIX:=$(DESTDIR)/usr
CONFDIR:=$(DESTDIR)/etc/mandos
KEYDIR:=$(DESTDIR)/etc/keys/mandos
MANDIR:=$(PREFIX)/share/man
INITRAMFSTOOLS:=$(DESTDIR)/usr/share/initramfs-tools
STATEDIR:=$(DESTDIR)/var/lib/mandos
LIBDIR:=$(shell \
	for d in \
	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
			echo "$(DESTDIR)$$d"; \
			break; \
		fi; \
	done)
##

SYSTEMD:=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
TMPFILES:=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)

GNUTLS_CFLAGS:=$(shell pkg-config --cflags-only-I gnutls)
GNUTLS_LIBS:=$(shell pkg-config --libs gnutls)
AVAHI_CFLAGS:=$(shell pkg-config --cflags-only-I avahi-core)
AVAHI_LIBS:=$(shell pkg-config --libs avahi-core)
GPGME_CFLAGS:=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
GPGME_LIBS:=$(shell gpgme-config --libs; getconf LFS_LIBS; \
	getconf LFS_LDFLAGS)
LIBNL3_CFLAGS:=$(shell pkg-config --cflags-only-I libnl-route-3.0)
LIBNL3_LIBS:=$(shell pkg-config --libs libnl-route-3.0)

# Do not change these two
CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
	$(OPTIMIZE) $(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) \
	$(GPGME_CFLAGS) -DVERSION='"$(version)"'
LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))

# Commands to format a DocBook <refentry> document into a manual page
DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
	--param man.charmap.use.subset		0 \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	$(notdir $<); \
	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
	fi >/dev/null)

DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	--param citerefentry.link		1 \
	--output $@ \
	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
	$<; $(HTMLPOST) $@)
# Fix citerefentry links
HTMLPOST:=$(SED) --in-place \
	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'

PLUGINS:=plugins.d/password-prompt plugins.d/mandos-client \
	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
	plugins.d/plymouth
PLUGIN_HELPERS:=plugin-helpers/mandos-client-iprouteadddel
CPROGS:=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
PROGS:=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
DOCS:=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
	plugins.d/mandos-client.8mandos \
	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
	plugins.d/plymouth.8mandos intro.8mandos

htmldocs:=$(addsuffix .xhtml,$(DOCS))

objects:=$(addsuffix .o,$(CPROGS))

all: $(PROGS) mandos.lsm

doc: $(DOCS)

html: $(htmldocs)

%.5: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.5.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8mandos: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8mandos.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

intro.8mandos: intro.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.8.xhtml: mandos.xml common.ent mandos-options.xml \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-keygen.8: mandos-keygen.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-monitor.8: mandos-monitor.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-monitor.8.xhtml: mandos-monitor.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-ctl.8: mandos-ctl.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-ctl.8.xhtml: mandos-ctl.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.conf.5.xhtml: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOHTML)

plugin-runner.8mandos: plugin-runner.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
plugin-runner.8mandos.xhtml: plugin-runner.xml common.ent \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOMAN)
plugins.d/mandos-client.8mandos.xhtml: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

# Update all these files with version number $(version)
common.ent: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
		$@)

mandos: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-keygen: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-ctl: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-monitor: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos.lsm: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(Version:\).*/\1\t$(version)/' \
		$@)
	$(strip $(SED) --in-place \
		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
		$@)
	$(strip $(SED) --in-place \
		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
		$@)

# Need to add the GnuTLS, Avahi and GPGME libraries, and can't use
# -fsanitize=leak because GnuTLS and GPGME both leak memory.
plugins.d/mandos-client: plugins.d/mandos-client.c
	$(CC) $(filter-out -fsanitize=leak,$(CFLAGS)) $(strip\
		) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(strip\
		) -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@

plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
		) $(LOADLIBES) $(LDLIBS) -o $@

.PHONY : all doc html clean distclean mostlyclean maintainer-clean \
	check run-client run-server install install-html \
	install-server install-client-nokey install-client uninstall \
	uninstall-server uninstall-client purge purge-server \
	purge-client

clean:
	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core

distclean: clean
mostlyclean: clean
maintainer-clean: clean
	-rm --force --recursive keydir confdir statedir

check:	all
	./mandos --check
	./mandos-ctl --check

# Run the client with a local config and key
run-client: all keydir/seckey.txt keydir/pubkey.txt
	@echo "###################################################################"
	@echo "# The following error messages are harmless and can be safely     #"
	@echo "# ignored:                                                        #"
	@echo "# From plugin-runner: setgid: Operation not permitted             #"
	@echo "#                     setuid: Operation not permitted             #"
	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
	@echo "# From mandos-client:                                             #"
	@echo "#             Failed to raise privileges: Operation not permitted #"
	@echo "#             Warning: network hook \"*\" exited with status *      #"
	@echo "#                                                                 #"
	@echo "# (The messages are caused by not running as root, but you should #"
	@echo "# NOT run \"make run-client\" as root unless you also unpacked and  #"
	@echo "# compiled Mandos as root, which is also NOT recommended.)        #"
	@echo "###################################################################"
# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
	./plugin-runner --plugin-dir=plugins.d \
		--plugin-helper-dir=plugin-helpers \
		--config-file=plugin-runner.conf \
		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
		$(CLIENTARGS)

# Used by run-client
keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
	install --directory keydir
	./mandos-keygen --dir keydir --force

# Run the server with a local config
run-server: confdir/mandos.conf confdir/clients.conf statedir
	./mandos --debug --no-dbus --configdir=confdir \
		--statedir=statedir $(SERVERARGS)

# Used by run-server
confdir/mandos.conf: mandos.conf
	install --directory confdir
	install --mode=u=rw,go=r $^ $@

=== debian/changelog ===
mandos (1.7.19-1) unstable; urgency=medium

  * New upstream release.
  * Fix "fails with "LeakSanitizer has encountered a fatal error"" by not
    using LeakSanitizer in affected binary (Closes: #886595)

 -- Teddy Hogeborn <teddy@recompile.se>  Thu, 22 Feb 2018 19:47:59 +0100

=== debian/control ===
Source: mandos
Section: admin
Priority: optional
Maintainer: Mandos Maintainers <mandos@recompile.se>
Uploaders: Teddy Hogeborn <teddy@recompile.se>,
	   Björn Påhlsson <belorn@recompile.se>
Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
	libgnutls28-dev (>= 3.3.0) | gnutls-dev (>= 3.3.0),
	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0),
	xsltproc, pkg-config, libnl-route-3-dev
Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
	python-dbus, python-gi
Standards-Version: 4.1.3
Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
Homepage: https://www.recompile.se/mandos

Package: mandos
Architecture: all
Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0),
	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6)
Recommends: ssh-client | fping
Description: server giving encrypted passwords to Mandos clients
 This is the server part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using an OpenPGP
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using the same OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

Package: mandos-client
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
	initramfs-tools, dpkg-dev (>=1.16.0)
Recommends: ssh, gnutls-bin | openssl
Breaks: dropbear (<= 0.53.1-1)
Enhances: cryptsetup
Description: do unattended reboots with an encrypted root file system
 This is the client part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using an OpenPGP
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using the same OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

=== debian/watch ===
version=4
opts=pgpmode=auto \
 https://ftp.recompile.se/pub/@PACKAGE@/@PACKAGE@@ANY_VERSION@(?:\.orig)?@ARCHIVE_EXT@

## mandos 1.7.20

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
 htmldir:=man
-version:=1.7.19
+version:=1.7.20
 SED:=sed
 
 USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -89,8 +89,7 @@
 
 # Do not change these two
 CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
-	$(OPTIMIZE) $(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) \
-	$(GPGME_CFLAGS) -DVERSION='"$(version)"'
+	$(OPTIMIZE) $(LANGUAGE) -DVERSION='"$(version)"'
 LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
@@ -257,6 +256,7 @@
 # -fsanitize=leak because GnuTLS and GPGME both leak memory.
 plugins.d/mandos-client: plugins.d/mandos-client.c
 	$(CC) $(filter-out -fsanitize=leak,$(CFLAGS)) $(strip\
+	) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) $(strip\
 		) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(strip\
 		) -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
 		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@

=== debian/changelog ===
mandos (1.7.20-1ubuntu1) cosmic; urgency=medium

  * Bump bizarre arbitrary {Build-,}Depends for gnutls 3.6.x compat.

 -- Adam Conrad <adconrad@ubuntu.com>  Sun, 14 Oct 2018 12:17:46 -0600

mandos (1.7.20-1) unstable; urgency=medium

  * New upstream release.
  * Fix "[tethys] mandos-client: Mandos client fails while booting but
    works from chroot into unpacked initramfs" by setting system clock if
    necessary (Closes: #894495)
  * Fix "initramfs boot script assumes internal cryptsetup implementation
    details and is now broken" by only using documented
    interfaces (Closes: #904899)
  * debian/mandos-client.dirs: Add
    "usr/share/initramfs-tools/scripts/local-premount" and
    "usr/share/initramfs-tools/conf.d", and remove
    "usr/share/initramfs-tools/conf-hooks.d".
  * debian/control (mandos-client/Depends): Add "(>= 0.99)" to dependency
    on "initramfs-tools".
  * debian/control (Source: mandos/Rules-Requires-Root): New; set to
    "binary-targets".
    (Standards-Version): Update to "4.2.0".

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 19 Aug 2018 22:14:04 +0200

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,28 @@
 Source: mandos
 Section: admin
 Priority: optional
-Maintainer: Mandos Maintainers <mandos@recompile.se>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Mandos Maintainers <mandos@recompile.se>
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
 	libgnutls28-dev (>= 3.3.0) | gnutls-dev (>= 3.3.0),
-	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0),
+	libgnutls28-dev (<< 3.7.0) | libgnutls30 (<< 3.7.0),
 	xsltproc, pkg-config, libnl-route-3-dev
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
-Standards-Version: 4.1.3
+Standards-Version: 4.2.0
 Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: https://www.recompile.se/mandos
+Rules-Requires-Root: binary-targets
 
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
 	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
-	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0),
+	libgnutls28-dev (<< 3.7.0) | libgnutls30 (<< 3.7.0),
 	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
 	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6)
 Recommends: ssh-client | fping
@@ -42,7 +44,7 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	initramfs-tools, dpkg-dev (>=1.16.0)
+	initramfs-tools (>= 0.99), dpkg-dev (>=1.16.0)
 Recommends: ssh, gnutls-bin | openssl
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup

## mandos 1.8.0

=== debian/changelog ===
mandos (1.8.0-1) unstable; urgency=medium

  * New upstream release.
  * Fix "(tries to) use GnuTLS OpenPGP support" by using raw public keys
    when available (Closes: #879538)
  * Fix "mandos : Depends: libgnutls30 (< 3.6.0) but 3.6.5-2 is to be
    installed" by now also allowing GnuTLS >= 3.6.6 (Closes: #916673)
  * debian/control (Standards-Version): Update to "4.3.0".
    (Package: mandos-client/Depends): Change from "cryptsetup" to
    "cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs".  Add "debconf (>=
    1.5.5) | debconf-2.0".
    (Source: mandos/Build-Depends): Also allow libgnutls30 (>= 3.6.6).
    (Package: mandos/Depends): - '' - and add debconf (>= 1.5.5) |
    debconf-2.0".
    (Package: mandos/Description): Alter description to match new design.
    (Package: mandos-client/Description): - '' -
    (Package: mandos-client/Depends): Move "gnutls-bin | openssl" to here
    from "Recommends".
  * debian/mandos-client.README.Debian: Add --tls-privkey and --tls-pubkey
    options to test command.
  * debian/mandos-client.postinst (create_key): Renamed to "create_keys"
    - all callers changed - and also create TLS key files.  Show notice if
    new TLS key files were created.
  * debian/mandos-client.postrm (purge): Also remove TLS key files.
  * debian/mandos-client.lintian-overrides: Override warnings.
  * debian/mandos-client.templates: New.
  * debian/mandos.lintian-overrides: Override warnings.
  * debian/mandos.postinst (configure): If GnuTLS 3.6.6 or later is
    detected, show an important notice (once) about the new key_id option
    required in clients.conf.
  * debian/mandos.templates: New.
  * debian/copyright: Update copyright year to 2019.

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 10 Feb 2019 05:52:49 +0100

## mandos 1.8.2

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
 htmldir:=man
-version:=1.7.20
+version:=1.8.2
 SED:=sed
 
 USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -284,7 +284,7 @@
 	./mandos-ctl --check
 
 # Run the client with a local config and key
-run-client: all keydir/seckey.txt keydir/pubkey.txt
+run-client: all keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem
 	@echo "###################################################################"
 	@echo "# The following error messages are harmless and can be safely     #"
 	@echo "# ignored:                                                        #"
@@ -303,21 +303,15 @@
 	./plugin-runner --plugin-dir=plugins.d \
 		--plugin-helper-dir=plugin-helpers \
 		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
+		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--tls-privkey=keydir/tls-privkey.pem,--tls-pubkey=keydir/tls-pubkey.pem,--network-hook-dir=network-hooks.d \
 		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
 		$(CLIENTARGS)
 
 # Used by run-client
-keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
+keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem: mandos-keygen
 	install --directory keydir
 	./mandos-keygen --dir keydir --force
 
 # Run the server with a local config
 run-server: confdir/mandos.conf confdir/clients.conf statedir
 	./mandos --debug --no-dbus --configdir=confdir \
-		--statedir=statedir $(SERVERARGS)
-
-# Used by run-server
-confdir/mandos.conf: mandos.conf
-	install --directory confdir
-	install --mode=u=rw,go=r $^ $@

=== debian/changelog ===
mandos (1.8.2-1) unstable; urgency=medium

  * New upstream release.
  * debian/mandos-client.postinst (create_keys): Ignore failure to remove
                                                 bad keys.

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 10 Feb 2019 11:44:56 +0100

mandos (1.8.1-1) unstable; urgency=high

  * New upstream release.
  * debian/mandos-client.postinst (create_keys): Remove any bad keys
    created by 1.8.0-1. Only create TLS keys if certtool succeeds.
  * debian/mandos.postinst (configure): Remove any bad keys from
    clients.conf, and inform the user if any were found.
  * debian/mandos.templates (mandos/removed_bad_key_ids): New message.

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 10 Feb 2019 10:00:21 +0100

=== debian/control ===
Source: mandos
Section: admin
Priority: optional
Maintainer: Mandos Maintainers <mandos@recompile.se>
Uploaders: Teddy Hogeborn <teddy@recompile.se>,
	   Björn Påhlsson <belorn@recompile.se>
Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
	libgnutls28-dev (>= 3.3.0) | gnutls-dev (>= 3.3.0),
	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0)
	| libgnutls30 (>= 3.6.6),
	xsltproc, pkg-config, libnl-route-3-dev
Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
	python-dbus, python-gi
Standards-Version: 4.3.0
Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
Homepage: https://www.recompile.se/mandos
Rules-Requires-Root: binary-targets

Package: mandos
Architecture: all
Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0)
	| libgnutls30 (>= 3.6.6),
	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6),
	debconf (>= 1.5.5) | debconf-2.0
Recommends: ssh-client | fping
Description: server giving encrypted passwords to Mandos clients
 This is the server part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using a TLS public
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using an OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

Package: mandos-client
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser,
	cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs,
	initramfs-tools (>= 0.99), dpkg-dev (>=1.16.0),
	gnutls-bin (>= 3.6.6) | openssl (>= 1.1.0),
	debconf (>= 1.5.5) | debconf-2.0
Recommends: ssh
Breaks: dropbear (<= 0.53.1-1)
Enhances: cryptsetup
Description: do unattended reboots with an encrypted root file system
 This is the client part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using a TLS public
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using an OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

## mandos 1.8.3

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
 htmldir:=man
-version:=1.8.2
+version:=1.8.3
 SED:=sed
 
 USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.8.3-2) unstable; urgency=medium

  * debian/rules (override_dh_shlibdeps-arch): New; conditionally edit
    debian/control before running dh_shlibdeps.

 -- Teddy Hogeborn <teddy@recompile.se>  Mon, 11 Feb 2019 12:49:57 +0100

mandos (1.8.3-1) unstable; urgency=medium

  * New upstream release.
  * debian/watch: Make the ".orig" file name suffix non-optional;
    otherwise uscan thinks that ".orig" is part of the version number.
  * debian/control (Build-Depends): Changed GnuTLS dependencies; move
    3.6.6 alternative to first in list, and remove dependencies on the
    virtual package "gnutls-dev", since we need the version restrictions.
    (Package: mandos/Depends): Remove dependency on libgnutls28-dev
    package.
    (Package: mandos/Suggests): New; set to "libc6-dev, c-compiler". (Used
    to find value of "SO_BINDTODEVICE").
    (Package: mandos-client/Depends): Don't depend on openssl anymore;
    instead depend on either a gnutls-bin (>= 3.6.6) (in which case TLS
    key generation will work), or on libgnutls30 (<< 3.6.0) (in which case
    TLS key generation will not be needed).

 -- Teddy Hogeborn <teddy@recompile.se>  Mon, 11 Feb 2019 07:30:32 +0100

=== debian/rules ===
#!/usr/bin/make -f

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += OPTIMIZE=-O0
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
    MAKEFLAGS += -j$(NUMJOBS)
endif

%:
	dh $@

override_dh_auto_build-arch:
	LC_ALL=en_US.utf8 dh_auto_build -- all doc

override_dh_auto_build-indep:
	LC_ALL=en_US.utf8 dh_auto_build -- doc

override_dh_installinit-indep:
	dh_installinit --onlyscripts \
		--update-rcd-params="defaults 25 15"

override_dh_auto_install-indep:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server

override_dh_auto_install-arch:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
		install-client-nokey

override_dh_fixperms-arch:
	dh_fixperms --exclude etc/keys/mandos \
		--exclude etc/mandos/plugins.d \
		--exclude etc/mandos/plugin-helpers \
		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugins.d \
		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugin-helpers \
		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
	chmod --recursive g-w -- \
	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"

override_dh_fixperms-indep:
	dh_fixperms --exclude etc/mandos/clients.conf

override_dh_auto_test-arch: ;

# dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
# libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
# alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
# So we have to do this ugly hack to hide this build dependency if we
# compiled with libgnutls30 << 3.6.0.
override_dh_shlibdeps-arch:
	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
		--show libgnutls30); \
	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
		&& sed --in-place --expression='s/libgnutls28-dev (>= 3\.6\.6) | //' debian/control
	-grep libgnutls28 debian/control
	dh_shlibdeps

## mandos 1.8.4

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
 htmldir:=man
-version:=1.8.3
+version:=1.8.4
 SED:=sed
 
 USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.8.4-1) unstable; urgency=medium

  * Fix "dirs in initrd are not accessible by mandos plugin-runner" by
    making sure UMASK is set, no matter what other packages have installed
    in "/usr/share/initramfs-tools/conf-hooks.d". (Closes: #926641)
  * Fix "LeakSanitizer: detected memory leaks, fails to decrypt"
    by fixing memory leak in plugin-runner. (Closes: #926643)
  * debian/mandos-client.dirs: Add
    "usr/share/initramfs-tools/conf-hooks.d", needed by fix for #926641.

 -- Teddy Hogeborn <teddy@recompile.se>  Tue, 09 Apr 2019 22:05:39 +0200

mandos (1.8.3-3) unstable; urgency=medium

  * Fix "src:mandos: modifies d/control during build" by not doing that
    anymore.  (Closes: #922202)
  * debian/rules (override_dh_shlibdeps-arch): Commented out.

 -- Teddy Hogeborn <teddy@recompile.se>  Wed, 13 Feb 2019 09:52:39 +0100

=== debian/control ===
--- 
+++ 
@@ -6,9 +6,8 @@
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 10), docbook-xml, docbook-xsl,
 	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
-	libgnutls28-dev (>= 3.3.0) | gnutls-dev (>= 3.3.0),
-	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0)
-	| libgnutls30 (>= 3.6.6),
+	libgnutls28-dev (>= 3.3.0),
+	libgnutls28-dev (>= 3.6.6) | libgnutls28-dev (<< 3.6.0),
 	xsltproc, pkg-config, libnl-route-3-dev
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
@@ -21,13 +20,13 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
-	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
-	libgnutls28-dev (<< 3.6.0) | libgnutls30 (<< 3.6.0)
-	| libgnutls30 (>= 3.6.6),
+	libgnutls30 (>= 3.3.0),
+	libgnutls30 (>= 3.6.6) | libgnutls30 (<< 3.6.0),
 	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
 	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6),
 	debconf (>= 1.5.5) | debconf-2.0
 Recommends: ssh-client | fping
+Suggests: libc6-dev | libc-dev, c-compiler
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
  computers to have encrypted root file systems and at the
@@ -48,7 +47,7 @@
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser,
 	cryptsetup (<< 2:2.0.3-1) | cryptsetup-initramfs,
 	initramfs-tools (>= 0.99), dpkg-dev (>=1.16.0),
-	gnutls-bin (>= 3.6.6) | openssl (>= 1.1.0),
+	gnutls-bin (>= 3.6.6) | libgnutls30 (<< 3.6.0),
 	debconf (>= 1.5.5) | debconf-2.0
 Recommends: ssh
 Breaks: dropbear (<= 0.53.1-1)

=== debian/rules ===
--- 
+++ 
@@ -44,15 +44,18 @@
 
 override_dh_auto_test-arch: ;
 
-# dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
-# libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
-# alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
-# So we have to do this ugly hack to hide this build dependency if we
-# compiled with libgnutls30 << 3.6.0.
-override_dh_shlibdeps-arch:
-	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
-		--show libgnutls30); \
-	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
-		&& sed --in-place --expression='s/libgnutls28-dev (>= 3\.6\.6) | //' debian/control
-	-grep libgnutls28 debian/control
-	dh_shlibdeps
+#bpo## dpkg-shlibdeps sees the "libgnutls28-dev (>= 3.6.6) |
+#bpo## libgnutls28-dev (<< 3.6.0)," in the build-dependencies not as two
+#bpo## alternatives, but as an absolute dependency on libgnutls30 >= 3.6.6.
+#bpo## So we have to do this ugly hack to hide this build dependency if we
+#bpo## compiled with libgnutls30 << 3.6.0.
+#bpo#override_dh_shlibdeps-arch:
+#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
+#bpo#		--show libgnutls30); \
+#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
+#bpo#		&& { cp --archive debian/control debian/control.orig; sed --expression='s/libgnutls28-dev (>= 3\.6\.6) |//' debian/control; }
+#bpo#	dh_shlibdeps
+#bpo#	-gnutls_version=$$(dpkg-query --showformat='$${Version}' \
+#bpo#		--show libgnutls30); \
+#bpo#	dpkg --compare-versions $$gnutls_version lt 3.6.0 \
+#bpo#		&& mv debian/control.orig debian/control

## mandos 1.8.5

=== Makefile ===
--- 
+++ 
@@ -10,10 +10,12 @@
 	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
 	-Wredundant-decls -Wnested-externs -Winline -Wvla \
 	-Wvolatile-register-var -Woverlength-strings
-#DEBUG:=-ggdb3 -fsanitize=address 
-# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
-# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
-FORTIFY:=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+
+#DEBUG:=-ggdb3 -fsanitize=address $(SANITIZE)
+## Check which sanitizing options can be used
+#SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
+#	echo 'int main(){}' | $(CC) --language=c $(option) \
+#	/dev/stdin -o /dev/null >/dev/null 2>&1 && echo $(option)))
 # <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
 ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
         -fsanitize=shift -fsanitize=integer-divide-by-zero \
@@ -23,11 +25,11 @@
         -fsanitize=object-size -fsanitize=float-divide-by-zero \
         -fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
         -fsanitize=returns-nonnull-attribute -fsanitize=bool \
-        -fsanitize=enum
-# Check which sanitizing options can be used
-SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
-	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
-	-o /dev/null >/dev/null 2>&1 && echo $(option)))
+        -fsanitize=enum -fsanitize-address-use-after-scope
+
+# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
+# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
+FORTIFY:=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 LINK_FORTIFY_LD:=-z relro -z now
 LINK_FORTIFY:=
 
@@ -40,11 +42,13 @@
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
 htmldir:=man
-version:=1.8.4
+version:=1.8.5
 SED:=sed
 
-USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
+USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos \
+	|| getent passwd nobody || echo 65534)))
+GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos \
+	|| getent group nogroup || echo 65534)))
 
 ## Use these settings for a traditional /usr/local install
 # PREFIX:=$(DESTDIR)/usr/local
@@ -52,6 +56,7 @@
 # KEYDIR:=$(DESTDIR)/etc/mandos/keys
 # MANDIR:=$(PREFIX)/man
 # INITRAMFSTOOLS:=$(DESTDIR)/etc/initramfs-tools
+# DRACUTMODULE:=$(DESTDIR)/usr/lib/dracut/modules.d/90mandos
 # STATEDIR:=$(DESTDIR)/var/lib/mandos
 # LIBDIR:=$(PREFIX)/lib
 ##
@@ -62,6 +67,7 @@
 KEYDIR:=$(DESTDIR)/etc/keys/mandos
 MANDIR:=$(PREFIX)/share/man
 INITRAMFSTOOLS:=$(DESTDIR)/usr/share/initramfs-tools
+DRACUTMODULE:=$(DESTDIR)/usr/lib/dracut/modules.d/90mandos
 STATEDIR:=$(DESTDIR)/var/lib/mandos
 LIBDIR:=$(shell \
 	for d in \
@@ -86,11 +92,14 @@
 	getconf LFS_LDFLAGS)
 LIBNL3_CFLAGS:=$(shell pkg-config --cflags-only-I libnl-route-3.0)
 LIBNL3_LIBS:=$(shell pkg-config --libs libnl-route-3.0)
+GLIB_CFLAGS:=$(shell pkg-config --cflags glib-2.0)
+GLIB_LIBS:=$(shell pkg-config --libs glib-2.0)
 
 # Do not change these two
-CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
+CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) \
 	$(OPTIMIZE) $(LANGUAGE) -DVERSION='"$(version)"'
-LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
+LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(strip \
+	) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
 DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
@@ -102,9 +111,9 @@
 	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
 	$(notdir $<); \
 	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
-	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
-	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
-	fi >/dev/null)
+	&& command -v man >/dev/null; then LANG=en_US.UTF-8 \
+	MANWIDTH=80 man --warnings --encoding=UTF-8 --local-file \
+	$(notdir $@); fi >/dev/null)
 
 DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
 	--param make.year.ranges		1 \
@@ -123,10 +132,12 @@
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
 PLUGIN_HELPERS:=plugin-helpers/mandos-client-iprouteadddel
-CPROGS:=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+CPROGS:=plugin-runner dracut-module/password-agent $(PLUGINS) \
+	$(PLUGIN_HELPERS)
 PROGS:=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
 DOCS:=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
+	dracut-module/password-agent.8mandos \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
@@ -204,6 +215,15 @@
 		overview.xml legalnotice.xml
 	$(DOCBOOKTOHTML)
 
+dracut-module/password-agent.8mandos: \
+		dracut-module/password-agent.xml common.ent \
+		overview.xml legalnotice.xml
+	$(DOCBOOKTOMAN)
+dracut-module/password-agent.8mandos.xhtml: \
+		dracut-module/password-agent.xml common.ent \
+		overview.xml legalnotice.xml
+	$(DOCBOOKTOHTML)
+
 plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
 					common.ent \
 					mandos-options.xml \
@@ -252,17 +272,21 @@
 		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
 		$@)
 
-# Need to add the GnuTLS, Avahi and GPGME libraries, and can't use
-# -fsanitize=leak because GnuTLS and GPGME both leak memory.
+# Need to add the GnuTLS, Avahi and GPGME libraries
 plugins.d/mandos-client: plugins.d/mandos-client.c
-	$(CC) $(filter-out -fsanitize=leak,$(CFLAGS)) $(strip\
-	) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) $(strip\
-		) $(CPPFLAGS) $(LDFLAGS) $(TARGET_ARCH) $^ $(strip\
-		) -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
-		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@
-
+	$(LINK.c) $^ $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(strip\
+		) $(GPGME_CFLAGS) $(GNUTLS_LIBS) $(strip\
+		) $(AVAHI_LIBS) $(GPGME_LIBS) $(LOADLIBES) $(strip\
+		) $(LDLIBS) -o $@
+
+# Need to add the libnl-route library
 plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
 	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
+		) $(LOADLIBES) $(LDLIBS) -o $@
+
+# Need to add the GLib and pthread libraries
+dracut-module/password-agent: dracut-module/password-agent.c
+	$(LINK.c) $(GLIB_CFLAGS) $^ $(GLIB_LIBS) -lpthread $(strip\
 		) $(LOADLIBES) $(LDLIBS) -o $@
 
 .PHONY : all doc html clean distclean mostlyclean maintainer-clean \
@@ -279,9 +303,13 @@
 maintainer-clean: clean
 	-rm --force --recursive keydir confdir statedir
 
-check:	all
+check: all
 	./mandos --check
 	./mandos-ctl --check
+	./mandos-keygen --version
+	./plugin-runner --version
+	./plugin-helpers/mandos-client-iprouteadddel --version
+	./dracut-module/password-agent --test
 
 # Run the client with a local config and key
 run-client: all keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem
@@ -298,20 +326,3 @@
 	@echo "# (The messages are caused by not running as root, but you should #"
 	@echo "# NOT run \"make run-client\" as root unless you also unpacked and  #"
 	@echo "# compiled Mandos as root, which is also NOT recommended.)        #"
-	@echo "###################################################################"
-# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
-	./plugin-runner --plugin-dir=plugins.d \
-		--plugin-helper-dir=plugin-helpers \
-		--config-file=plugin-runner.conf \
-		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--tls-privkey=keydir/tls-privkey.pem,--tls-pubkey=keydir/tls-pubkey.pem,--network-hook-dir=network-hooks.d \
-		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
-		$(CLIENTARGS)
-
-# Used by run-client
-keydir/seckey.txt keydir/pubkey.txt keydir/tls-privkey.pem keydir/tls-pubkey.pem: mandos-keygen
-	install --directory keydir
-	./mandos-keygen --dir keydir --force
-
-# Run the server with a local config
-run-server: confdir/mandos.conf confdir/clients.conf statedir
-	./mandos --debug --no-dbus --configdir=confdir \

=== debian/changelog ===
mandos (1.8.5-1) unstable; urgency=medium

  * New upstream release.
  * Fix "does not reap children" by reaping children (Closes: #933387)
  * debian/mandos-client.README.Debian: Use new-style interface name.
  * debian/tests/control: New file; implements autopkgtest support.
  * debian/mandos-client.lintian-overrides
    (manpage-has-errors-from-man): Remove; unnecessary.
  * debian/mandos.lintian-overrides
    (init.d-script-needs-depends-on-lsb-base): - '' -
  * debian/mandos-client.postinst (update_initramfs): Upstream now
    supports dracut(8), so update commands here to and run the correct
    command to update initramfs.
  * debian/control (Build-Depends): Add GLib -dev package.
    (mandos-client/Depends): Add dracut(8) as an alternative dependency to
    initramfs-tools.
    (mandos-client/Conflicts): New; set to "dracut-config-generic".
    (debian/mandos-client.README.Debian): Update for dracut(8) support.
  * debian/mandos-client.templates: Reflowed by debconf-gettextize(1).
  * debian/mandos.templates: - '' -
  * debian/po/POTFILES.in: New.
  * debian/po/templates.pot: - '' -
  * debian/source/lintian-overrides: New.
  * debian/control (Standards-Version): Update to "4.4.0".

 -- Teddy Hogeborn <teddy@recompile.se>  Tue, 30 Jul 2019 20:41:29 +0200
